Tag Archives: 斐波那契

剑指 Offer 10- II. 青蛙跳台阶问题

剑指 Offer 10- II. 青蛙跳台阶问题

一只青蛙一次可以跳上1级台阶,也可以跳上2级台阶。求该青蛙跳上一个 n 级的台阶总共有多少种跳法。

答案需要取模 1e9+7(1000000007),如计算初始结果为:1000000008,请返回 1。

示例 1:

输入:n = 2
输出:2
示例 2:

输入:n = 7
输出:21
示例 3:

输入:n = 0
输出:1
提示:

0 <= n <= 100
注意:本题与主站 70 题相同:https://leetcode-cn.com/problems/climbing-stairs/

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/qing-wa-tiao-tai-jie-wen-ti-lcof
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。


对于跳到第n的位置,有两种来源,如果这一跳是2步,则f(n)=f(n-2),如果这一跳是1步,则f(n)=f(n-1),所以总的情况是f(n)=f(n-2)+f(n-1),也就是求斐波那契数列的第n项。

完整代码如下:

class Solution {
public:
    int numWays(int n) {
        if(n == 0) return 1;
        if(n == 1) return 1;
        if(n == 2) return 2;
        int a = 1, b = 2;
        for(int i = 3; i <= n; ++i) {
            int tmp = (a + b) % 1000000007;
            a = b;
            b = tmp;
        }
        return b;
    }
};

本代码提交AC,用时0MS。

剑指 Offer 10- I. 斐波那契数列

剑指 Offer 10- I. 斐波那契数列

写一个函数,输入 n ,求斐波那契(Fibonacci)数列的第 n 项。斐波那契数列的定义如下:

F(0) = 0,   F(1) = 1
F(N) = F(N – 1) + F(N – 2), 其中 N > 1.
斐波那契数列由 0 和 1 开始,之后的斐波那契数就是由之前的两数相加而得出。

答案需要取模 1e9+7(1000000007),如计算初始结果为:1000000008,请返回 1。

示例 1:

输入:n = 2
输出:1
示例 2:

输入:n = 5
输出:5
 

提示:

0 <= n <= 100
注意:本题与主站 509 题相同:https://leetcode-cn.com/problems/fibonacci-number/

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/fei-bo-na-qi-shu-lie-lcof
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。


求斐波那契数列的第n项。看之前的POJ题解: http://code.bitjoy.net/2017/05/04/poj-3070-fibonacci/

一共有三种解法。常规解法就是无脑递归调用。关键是如何分析这种解法的时空复杂度。无脑调用是F(n)=F(n-1)+F(n-2)。想象一下,递归调用二叉树( https://wmjtxt.github.io/2018/12/26/three_method_of_fibonacci/ )。每个节点都会分裂出2个孩子,然后孩子继续2倍分裂,所以总调用次数大概是$O(2^n)$,这是时间复杂度。空间复杂度就是递归调用的栈深度,就是树的高度,大概是$O(n)$。

常规解法是,DP的思路,每次保留数列前两项,然后不断更新这两个数。时间复杂度是$O(n)$,空间复杂度是O(1)。完整代码如下:

class Solution {
public:
    int fib(int n) {
        if(n == 0) return 0;
        if(n == 1) return 1;
        long long a = 0, b = 1;
        for(int i = 2; i <= n; ++i) {
            long long tmp = a + b;
            tmp %= 1000000007;
            a = b;
            b = tmp;
        }
        return b;
    }
};

本代码提交AC,用时0MS。

最优的解法是矩阵快速幂的方法,求矩阵[[1,1],[1,0]]的n次幂,然后矩阵逆对角线位置的值就是F(n)的值。快速幂可以做到$O(lg(n))$的时间复杂度,完整代码如下:

typedef long long LL;

class Solution {
private:
    vector<vector<LL>> multiply(vector<vector<LL>> &m1, vector<vector<LL>> &m2) {
        int n = m1.size();
        vector<vector<LL>> ans(n, vector<LL>(n, 0));
        for(int i = 0; i < n; ++i) {
            for(int j = 0; j < n; ++j) {
                for(int k = 0; k < n; ++k) {
                    ans[i][j] += m1[i][k] * m2[k][j] % 1000000007;
                }
            }
        }
        return ans;
    }
public:
    int fib(int n) {
        if(n == 0) return 0;
        if(n == 1) return 1;

        vector<vector<LL>> matrix = {{1,1},{1,0}};

        vector<vector<LL>> ans = {{1,0},{0,1}};
        while(n != 0) {
            if(n % 2 == 1) ans = multiply(ans, matrix);
            matrix = multiply(matrix, matrix);
            n >>= 1;
        }

        return ans[0][1] % 1000000007;
    }
};

本代码提交AC,用时4MS。

POJ 3070-Fibonacci

POJ 3070-Fibonacci

Fibonacci

Time Limit: 1000MSMemory Limit: 65536K
Total Submissions: 26421Accepted: 17616

Description

In the Fibonacci integer sequence, F0 = 0, F1 = 1, and Fn = Fn − 1 + Fn − 2 for n ≥ 2. For example, the first ten terms of the Fibonacci sequence are:

0, 1, 1, 2, 3, 5, 8, 13, 21, 34, …

An alternative formula for the Fibonacci sequence is

.

Given an integer n, your goal is to compute the last 4 digits of Fn.

Input

The input test file will contain multiple test cases. Each test case consists of a single line containing n (where 0 ≤ n ≤ 1,000,000,000). The end-of-file is denoted by a single line containing the number −1.

Output

For each test case, print the last four digits of Fn. If the last four digits of Fn are all zeros, print ‘0’; otherwise, omit any leading zeros (i.e., print Fn mod 10000).

Sample Input

0
9
999999999
1000000000
-1

Sample Output

0
34
626
6875

Hint

As a reminder, matrix multiplication is associative, and the product of two 2 × 2 matrices is given by

.

Also, note that raising any 2 × 2 matrix to the 0th power gives the identity matrix:

.

SourceStanford Local 2006


斐波那契数列是这样一个数列:0,1,1,2,3,5…,其数学定义为:

$$\begin{equation}f(n)=\begin{cases} 0, & n=0;\ 1, & n=1;\ f(n-1)+f(n-2), & n>1.\end{cases}\end{equation}$$

最简单的递归解法为:

typedef long long LL;
LL Fib1(int n)
{
    if (n == 0)
        return 0;
    if (n == 1)
        return 1;
    return Fib1(n – 1) + Fib1(n – 2);
}

 这种算法的时间复杂度是 $O(2^n)$。 但是这种解法有很多重复计算,比如算f(8)=f(7)+f(6)时,f(7)重复计算了f(6)。所以我们可以从小开始算起,把f(n)的前两个值保存下来,每次滚动赋值,代码如下:

LL Fib2(int n)
{
    if (n == 0)
        return 0;
    if (n == 1)
        return 1;
    LL fn_2 = 0, fn_1 = 1, ans = 0;
    for (int i = 2; i <= n; ++i) {
        ans = fn_1 + fn_2;
        fn_2 = fn_1;
        fn_1 = ans;
    }
    return ans;
}

这种算法的时间复杂度是 $O(n)$。 最近遇到快速幂相关的题,发现求解斐波那契数列也可以用快速幂来求解,时间复杂度居然能降到 $O(lg(n))$。

题目的图中给出了斐波那契数列的矩阵形式,f(n)为矩阵[1,1;1,0]的n次幂的第一行第二个数。可以用归纳法证明矩阵的n次幂和数的n次幂都可以用快速幂来求解,时间复杂度能降到 $O(lg(n))$。 代码如下:

const int MAXN = 2;
vector<vector<LL> > multi(const vector<vector<LL> >& mat1, const vector<vector<LL> >& mat2)
{
    vector<vector<LL> > mat(MAXN, vector<LL>(MAXN, 0));
    for (int i = 0; i < MAXN; ++i) {
        for (int j = 0; j < MAXN; ++j) {
            for (int k = 0; k < MAXN; ++k) {
                mat[i][j] += mat1[i][k] * mat2[k][j];
            }
        }
    }
    return mat;
}
vector<vector<LL> > fastPow(vector<vector<LL> >& mat1, int n)
{
    vector<vector<LL> > mat(MAXN, vector<LL>(MAXN, 0));
    for (int i = 0; i < MAXN; ++i)
        mat[i][i] = 1;
    while (n != 0) {
        if (n & 1)
            mat = multi(mat, mat1);
        mat1 = multi(mat1, mat1);
        n >>= 1;
    }
    return mat;
}
LL Fib3(int n)
{
    if (n == 0)
        return 0;
    if (n == 1)
        return 1;
    vector<vector<LL> > mat = { { 1, 1 }, { 1, 0 } };
    vector<vector<LL> > matN = fastPow(mat, n);
    return matN[0][1];
}

POJ这题的代码如下,古老的POJ居然不支持第37行的vector初始化,崩溃。

#include <iostream> #include<cstdio>
#include <vector>
using namespace std;
typedef long long LL;
const int MAXN = 2;
const int MOD = 10000;
vector<vector<LL> > multi(const vector<vector<LL> >& mat1, const vector<vector<LL> >& mat2)
{
    vector<vector<LL> > mat(MAXN, vector<LL>(MAXN, 0));
    for (int i = 0; i < MAXN; ++i) {
        for (int j = 0; j < MAXN; ++j) {
            for (int k = 0; k < MAXN; ++k) {
                mat[i][j] = (mat[i][j] + mat1[i][k] * mat2[k][j]) % MOD;
            }
        }
    }
    return mat;
}
vector<vector<LL> > fastPow(vector<vector<LL> >& mat1, int n)
{
    vector<vector<LL> > mat(MAXN, vector<LL>(MAXN, 0));
    for (int i = 0; i < MAXN; ++i)
        mat[i][i] = 1;
    while (n != 0) {
        if (n & 1)
            mat = multi(mat, mat1);
        mat1 = multi(mat1, mat1);
        n >>= 1;
    }
    return mat;
}
LL Fib3(int n)
{
    if (n == 0)
        return 0;
    if (n == 1)
        return 1;
    //vector<vector<LL>> mat = { { 1,1 },{ 1,0 } }; //———————–
    vector<vector<LL> > mat;
    vector<LL> r1;
    r1.push_back(1), r1.push_back(1);
    vector<LL> r2;
    r2.push_back(1), r2.push_back(0);
    mat.push_back(r1);
    mat.push_back(r2); //———————-
    vector<vector<LL> > matN = fastPow(mat, n);
    return matN[0][1];
}
int main()
{
    int n;
    while (scanf("%d", &n) && n != -1) {
        LL ans = Fib3(n);
        printf("%d\n", ans % MOD);
    }
    return 0;
}

本代码提交AC,用时32MS,真的好快呀。

LeetCode Climbing Stairs

70. Climbing Stairs

You are climbing a stair case. It takes n steps to reach to the top.

Each time you can either climb 1 or 2 steps. In how many distinct ways can you climb to the top?

Note: Given n will be a positive integer.

Example 1:

Input: 2
Output: 2
Explanation: There are two ways to climb to the top.
1. 1 step + 1 step
2. 2 steps

Example 2:

Input: 3
Output: 3
Explanation: There are three ways to climb to the top.
1. 1 step + 1 step + 1 step
2. 1 step + 2 steps
3. 2 steps + 1 step

虽然是easy模式,但是是很好的一道题。问爬一个有n个台阶的楼梯,每次只能跨1步或者2步,共有多少种方案。 使用DP解决,假设前n个台阶共有dp[n]种方案,来了一个新台阶第n+1个台阶,那么这个台阶可以单独1步跨,则方案数为dp[n];也可以和第n个台阶合在一起一次性跨2步,则还剩n-1个台阶,所以方案数为dp[n-1]。综合起来就是dp[n+1]=dp[n]+dp[n-1],这其实就是斐波那契数列。
求斐波那契数列的第n项是一个经典问题,如果使用原始的递归求解,则会有很多重复计算,导致超时:

class Solution {
public:
    int climbStairs(int n)
    {
        if (n == 1)
            return 1;
        if (n == 2)
            return 2;
        return climbStairs(n – 1) + climbStairs(n – 2);
    }
};

但是每次我们只需要前两项的数值,所以可以优化为:

class Solution {
public:
    int climbStairs(int n)
    {
        if (n == 1)
            return 1;
        if (n == 2)
            return 2;
        int a1 = 1, a2 = 2, tmp;
        for (int i = 3; i <= n; i++) {
            tmp = a1 + a2;
            swap(a1, a2);
            swap(a2, tmp);
        }
        return a2;
    }
};

本代码提交AC,用时0MS。